unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls, ComObj, WinSock;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ADOCommand: TADOCommand;
    ADOConnection: TADOConnection;
    ADOQuery: TADOQuery;
    Table: TADOTable;
    ADOQueryL: TADOQuery;
    Memo1: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GetExchange;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddData(s: string);
    procedure AddInfoData(s: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const mask: string = '\\report_server\mm$\Basa\*.txt';
const maskinfo: string = '\\report_server\mm$\Basa\*.nfo';
const path: string = '\\report_server\mm$\Basa\';
const dbdir: string = '\\report_server\mm$\Basa\DB\';

function IPBYNAME(s: String): string;
type pu_long = ^u_long;
var varTWSAData : TWSAData;
varPHostEnt : PHostEnt;
varTInAddr : TInAddr;
namebuf : Array[0..255] of ansichar;
begin
try
try
If WSAStartup($101,varTWSAData) <> 0 Then
Result := ''
Else Begin
FillChar(namebuf, 256, 0);
StrPCopy(@(namebuf[0]), AnsiString(s));
varPHostEnt := gethostbyname(namebuf);
if varPHostEnt = nil then
begin
Result := '';
end else begin
varTInAddr.S_addr := u_long(pu_long(varPHostEnt^.h_addr_list^)^);
Result := inet_ntoa(varTInAddr);
end;
End;
except
Result := '';
end;
finally
WSACleanup;
end;
end;


function GetEmail(s: string): string;
var
  i: integer;
begin
  Delete(s, 1, pos('/cn=', s) + 3);
  Delete(s, 1, pos('/cn=', s) + 3);
  Result := '';
  for i := 1 to length(s) do
  begin
    if CharInSet(s[i], ['a'..'z', 'A'..'Z']) then
      Result := Result + s[i]
    else
      break;
  end;

  Result := Result + '@zio.ru';

end;


function FixTel (s: string): string;
begin
s := Trim(s);

if pos(',', s)>0 then
result := copy(s, 0, pos(',', s) -1)
else
if pos(' ', s)>0 then
result := copy(s, 0, pos(' ', s) -1)
else result := s;

end;

function TrimName(s: String): String;
var
  i, n: integer;
  t: String;
  sstart, send: integer; lastspace: boolean;
begin


  t := Trim(UpperCase(s, loUserLocale));

  Result := '';


  sstart := -1;

  for I := 1 to length(t) do
  begin
    case (t[i]) of
      '', ''..'':
      begin
        if sstart = -1 then
          sstart := i else
             send := i;

      end;

      #$20:
      begin
        {-}
      end;

    end;
  end;


  lastspace := false;

 for I := 1 to length(t) do
  begin
    case (t[i]) of
    '', ''..'':
      begin
     result := result + t[i];
      lastspace := false;
      end;

      ' ':
      begin
      if (i in [sstart + 1..send - 1]) and (lastspace = false) then
      begin
      result := result + t[i];
      lastspace := true;
      end;

      end;

    end;
  end;


end;


procedure TForm1.AddData(s: string);
var SL, SL2: TStringList; p: TParameter; email: string;  advfound: boolean;
begin

Memo1.Lines.Add(s);
Application.ProcessMessages;


advfound := fileexists(changefileext(s, '.nfo'));

SL2 := TStringList.Create;
if advfound then
begin
SL2.LoadFromFile(changefileext(s, '.nfo'))
end else begin
SL2.Add('0');
SL2.Add('');
SL2.Add('0');
SL2.Add('');
SL2.Add('0');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
SL2.Add('');
end;

if SL2.Count = 11 then
begin
SL2.Add('');
end;

if SL2.Count = 12 then
begin
SL2.Add('');
end;

if SL2.Count = 13 then
begin
SL2.Add('');
end;

SL := TStringList.Create;
SL.LoadFromFile(s);

advfound := fileexists(changefileext(s, '.nfo'));

Adocommand.CommandText := 'DELETE FROM USERS WHERE HOST = :HOST';
p := adocommand.Parameters.ParamByName('HOST');
p.DataType := ftString;
p.Size := 70;
p.Value := UpperCase(SL[0], loUserLocale);
Adocommand.Execute;

Adocommand.CommandText := 'INSERT INTO USERS (HOST, USER, IP, FIO, TEL, ZDAN, ETAJ, KAB, SPEED, TYPE, RAM, CPU, HDD, OS, OSVER, W9XVER, OSBUILD, OSID, BIOS, PRINTER) '+
'VALUES (:HOST, :USER, :IP, :FIO, :TEL, :ZDAN, :ETAJ, :KAB, :SPEED, :TYPE, :RAM, :CPU, :HDD, :OS, :OSVER, :W9XVER, :OSBUILD, :OSID, :BIOS, :PRINTER)';
p := adocommand.Parameters.ParamByName('HOST');
p.DataType := ftString;
p.Size := 70;
p.Value := UpperCase(SL[0], loUserLocale);

p := adocommand.Parameters.ParamByName('USER');
p.DataType := ftString;
p.Size := 70;

if Trim(SL[1]) = '' then
begin
p.Value := (SL2[11]);
end else begin
p.Value := (SL[1]);
end;

p := adocommand.Parameters.ParamByName('IP');
p.DataType := ftString;
p.Size := 70;
if SL[2] <> '' then
p.Value := SL[2]
else
p.Value := SL2[12];

p := adocommand.Parameters.ParamByName('PRINTER');
p.DataType := ftString;
p.Size := 192;
p.Value := SL2[13];

p := adocommand.Parameters.ParamByName('FIO');
p.DataType := ftString;
p.Size := 70;
p.Value := TrimName(SL[3]);

p := adocommand.Parameters.ParamByName('TEL');
p.DataType := ftString;
p.Size := 70;
p.Value := FixTel(SL[4]);

p := adocommand.Parameters.ParamByName('ZDAN');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL[5]);

p := adocommand.Parameters.ParamByName('ETAJ');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL[6]);

p := adocommand.Parameters.ParamByName('KAB');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL[7]);

{-- nfo files --}


p := adocommand.Parameters.ParamByName('SPEED');
p.DataType := ftInteger;
p.Size := 0;
p.Value := (SL2[0]);

p := adocommand.Parameters.ParamByName('TYPE');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[1]);

p := adocommand.Parameters.ParamByName('RAM');
p.DataType := ftInteger;
p.Size := 0;
p.Value := (SL2[2]);

p := adocommand.Parameters.ParamByName('CPU');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[3]);

p := adocommand.Parameters.ParamByName('HDD');
p.DataType := ftInteger;
p.Size := 70;
p.Value := (SL2[4]);

p := adocommand.Parameters.ParamByName('OS');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[5]);

p := adocommand.Parameters.ParamByName('OSVER');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[6]);

p := adocommand.Parameters.ParamByName('W9XVER');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[7]);

p := adocommand.Parameters.ParamByName('OSBUILD');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[8]);

p := adocommand.Parameters.ParamByName('OSID');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[9]);

p := adocommand.Parameters.ParamByName('BIOS');
p.DataType := ftString;
p.Size := 70;
p.Value := (SL2[10]);

sl2.Free;


AdoCommand.Execute;
SL.Free;

end;




procedure TForm1.GetExchange;
const
  olFolderContacts = $0000000A;
var
  outlook, NameSpace, Contacts, Contact: olevariant;
  i: integer; NewFIO: string;
begin

  //------------------------------------------------------------------------------------------------------------------------------------//



  if fileexists(dbdir +  'mexport.dbf') then
  begin
    AdoCommand.CommandText := 'DROP TABLE MEXPORT;';
    AdoCommand.Execute;
  end;


  AdoCommand.CommandText := 'CREATE TABLE MEXPORT (FIO VARCHAR(70), EMAIL VARCHAR(64))';
  AdoCommand.Execute;

  AdoCommand.CommandText := 'CREATE INDEX FIO_IDX ON MEXPORT (FIO)';
  AdoCommand.Execute;

  table.TableName := 'mexport';
  table.Open;

  outlook := CreateOleObject('Outlook.Application');
  NameSpace := outlook.GetNameSpace('MAPI');

  Contacts := NameSpace.AddressLists('  ');




  for i := 1 to Contacts.AddressEntries.Count do

  begin
    Contact := Contacts.AddressEntries(i);
    table.Append;
    table.FieldByName('FIO').AsString := UpperCase(Trim(Contact.Name), louserLocale);
    table.FieldByName('EMAIL').AsString := GetEmail(Contact.Address);
    table.Post;
  end;

  table.Close;
  adoconnection.Close;
  Outlook := Unassigned;
  //-----------------------------------------------------------------------------------//




  //------------------------------------------------------------------------------------------------------------------------------------//
 

  if fileexists(dbdir + 'texport.dbf') then
  begin
    AdoCommand.CommandText := 'DROP TABLE TEXPORT;';
    AdoCommand.Execute;
  end;


  AdoCommand.CommandText := 'CREATE TABLE TEXPORT (FIO VARCHAR(70), TEL VARCHAR(64))';
  AdoCommand.Execute;

  AdoCommand.CommandText := 'CREATE INDEX FIO_IDX ON TEXPORT (FIO)';
  AdoCommand.Execute;

  table.TableName := 'texport';
  table.Open;

  outlook := CreateOleObject('Outlook.Application');
  NameSpace := outlook.GetNameSpace('MAPI');

  Contacts := NameSpace.GetDefaultFolder(olFolderContacts);




  for i := 1 to Contacts.Items.Count do

  begin
    Contact := Contacts.Items[i];
    NewFIO := Trim(TrimName(Contact.LastName) + ' ' +  TrimName(Contact.FirstName));

    if (Trim(Contact.BusinessTelephoneNumber) <> '') and (NewFIO <> '') then
    begin
      table.Append;
      table.FieldByName('FIO').AsString := NewFIO;
      table.FieldByName('TEL').AsString := FixTel(Contact.BusinessTelephoneNumber);
      table.Post;
    end;
  end;

  table.Close;

  Outlook := Unassigned;
  //-----------------------------------------------------------------------------------//

end;



procedure TForm1.AddInfoData(s: string);
var SL: TStringList; p: TParameter; email: string;  ready: boolean;
begin



SL := TStringList.Create;
SL.LoadFromFile(s);
s := ExtractFileName(s);
s := UpperCase(copy(s, 0, length(s) - 4), loUserLocale);

if SL.Count = 11 then SL.Add('');
if SL.Count = 12 then SL.Add(IPBYNAME(s));
if SL.Count = 13 then SL.Add('');


AdoQuery.SQL.Text := 'SELECT COUNT (HOST) AS COUNT FROM USERS WHERE HOST = :HOST';
p := AdoQuery.Parameters.ParamByName('HOST');
p.DataType := ftString;
p.Size := 70;
p.Value := s;
AdoQuery.Open;
AdoQuery.First;
ready := AdoQuery.FieldByName('count').AsInteger = 0;

if ready then begin

Memo1.Lines.Add(s);
Application.ProcessMessages;

Adocommand.CommandText := 'INSERT INTO USERS (HOST, USER, IP, FIO, TEL, ZDAN, ETAJ, KAB, SPEED, TYPE, RAM, CPU, HDD, OS, OSVER, W9XVER, OSBUILD, OSID, BIOS, PRINTER) '+
'VALUES (:HOST, :USER, :IP, :FIO, :TEL, :ZDAN, :ETAJ, :KAB, :SPEED, :TYPE, :RAM, :CPU, :HDD, :OS, :OSVER, :W9XVER, :OSBUILD, :OSID, :BIOS, :PRINTER)';
p := adocommand.Parameters.ParamByName('HOST');
p.DataType := ftString;
p.Size := 70;
p.Value := s;

p := adocommand.Parameters.ParamByName('USER');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[11];

p := adocommand.Parameters.ParamByName('IP');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[12];

p := adocommand.Parameters.ParamByName('PRINTER');
p.DataType := ftString;
p.Size := 192;
p.Value := SL[13];


p := adocommand.Parameters.ParamByName('FIO');
p.DataType := ftString;
p.Size := 70;
p.Value := '  ';

p := adocommand.Parameters.ParamByName('TEL');
p.DataType := ftString;
p.Size := 70;
p.Value := '';

p := adocommand.Parameters.ParamByName('ZDAN');
p.DataType := ftString;
p.Size := 70;
p.Value := '';

p := adocommand.Parameters.ParamByName('ETAJ');
p.DataType := ftString;
p.Size := 70;
p.Value := '';

p := adocommand.Parameters.ParamByName('KAB');
p.DataType := ftString;
p.Size := 70;
p.Value := '';

p := adocommand.Parameters.ParamByName('SPEED');
p.DataType := ftInteger;
p.Size := 0;
p.Value := SL[0];

p := adocommand.Parameters.ParamByName('TYPE');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[1];

p := adocommand.Parameters.ParamByName('RAM');
p.DataType := ftInteger;
p.Size := 0;
p.Value := SL[2];

p := adocommand.Parameters.ParamByName('CPU');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[3];

p := adocommand.Parameters.ParamByName('HDD');
p.DataType := ftInteger;
p.Size := 70;
p.Value := SL[4];

p := adocommand.Parameters.ParamByName('OS');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[5];

p := adocommand.Parameters.ParamByName('OSVER');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[6];

p := adocommand.Parameters.ParamByName('W9XVER');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[7];

p := adocommand.Parameters.ParamByName('OSBUILD');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[8];

p := adocommand.Parameters.ParamByName('OSID');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[9];

p := adocommand.Parameters.ParamByName('BIOS');
p.DataType := ftString;
p.Size := 70;
p.Value := SL[10];


AdoCommand.Execute;
SL.Free;

end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var SR: TSearchRec; p: TParameter;
begin
Button1.Enabled := False;

GetExchange;


if FindFirst(mask, faAnyFile, SR) = 0  then
repeat
AddData(Path + SR.Name);
until FindNext(SR) <> 0;
FindClose(SR);


if FindFirst(maskinfo, faAnyFile, SR) = 0  then
repeat
AddInfoData(Path + SR.Name);
until FindNext(SR) <> 0;
FindClose(SR);


// E-Mail //
  adoquery.SQL.Text := 'SELECT FIO, EMAIL FROM MEXPORT';
  adoquery.Open;
  adoquery.First;

  while not adoquery.Eof do
  begin

  //
  adoqueryl.SQL.Text := 'SELECT COUNT(HOST) AS COUNT FROM USERS WHERE FIO = :FIO';
  p := adoqueryl.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;
  adoqueryl.Open;
  adoqueryl.First;

  if adoqueryl.FieldByName('COUNT').AsInteger = 0 then begin
  adocommand.CommandText := 'INSERT INTO USERS (FIO) VALUES (:FIO)';
  p := adocommand.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;
  end;

  adocommand.CommandText := 'UPDATE USERS SET EMAIL = :EMAIL WHERE FIO = :FIO';

  p := adocommand.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;

  p := adocommand.Parameters.ParamByName('EMAIL');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('EMAIL').AsString;
  adocommand.Execute;
  //
  adoquery.Next;
  end;

  // TEL2

  adoquery.SQL.Text := 'SELECT FIO, TEL FROM TEXPORT';
  adoquery.Open;
  adoquery.First;

  while not adoquery.Eof do
  begin

  //
  adoqueryl.SQL.Text := 'SELECT COUNT(HOST) AS COUNT FROM USERS WHERE FIO = :FIO';
  p := adoqueryl.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;
  adoqueryl.Open;
  adoqueryl.First;

  if adoqueryl.FieldByName('COUNT').AsInteger = 0 then begin
  adocommand.CommandText := 'INSERT INTO USERS (FIO) VALUES (:FIO)';
  p := adocommand.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;
  end;

  adocommand.CommandText := 'UPDATE USERS SET TEL2 = :TEL2 WHERE FIO = :FIO';

  p := adocommand.Parameters.ParamByName('FIO');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('FIO').AsString;

  p := adocommand.Parameters.ParamByName('TEL2');
  p.DataType := ftString;
  p.Size := 70;
  p.Value := adoquery.FieldByName('TEL').AsString;
  adocommand.Execute;
  //
  adoquery.Next;
  end;

if adoconnection.Connected then
adoconnection.Close;

Button1.Enabled := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
ShowMessage(ipbyname('oit01'));
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
onactivate := nil;

 adoconnection.ConnectionString :=
    'DRIVER=Microsoft dBase Driver (*.dbf);DriverID=533;FIL=dBase 5.0;DefaultDir=' + DBDIR;

  if not fileexists(dbdir + 'users.dbf') then
  begin
  AdoCommand.CommandText := 'CREATE TABLE USERS (HOST VARCHAR(70), USER VARCHAR(70),' +
  ' IP VARCHAR(70), FIO VARCHAR(70), TEL VARCHAR(70), ZDAN VARCHAR(70), ETAJ VARCHAR(70), '+
  'KAB VARCHAR(70), EMAIL VARCHAR(70), TEL2 VARCHAR(70),' +
  'SPEED INTEGER, RAM INTEGER, TYPE VARCHAR(70), CPU VARCHAR(70), HDD INTEGER, OS VARCHAR(70),'+
  ' OSVER VARCHAR(70), W9XVER VARCHAR(70), OSBUILD VARCHAR(70), ' +
    ' OSID VARCHAR(70), BIOS VARCHAR(70), PRINTER VARCHAR (192));';
  AdoCommand.Execute;

  AdoCommand.CommandText := 'CREATE INDEX HOST_IDX ON USERS (HOST)';
  AdoCommand.CommandText := 'CREATE INDEX USER_IDX ON USERS (USER)';
  AdoCommand.CommandText := 'CREATE INDEX FIO_IDX ON USERS (FIO)';
  AdoCommand.CommandText := 'CREATE INDEX IP_IDX ON USERS (IP)';
  AdoCommand.CommandText := 'CREATE INDEX TEL_IDX ON USERS (TEL)';
  AdoCommand.CommandText := 'CREATE INDEX TEL2_IDX ON USERS (TEL2)';
  AdoCommand.CommandText := 'CREATE INDEX EMAIL_IDX ON USERS (EMAIL)';
  AdoCommand.CommandText := 'CREATE INDEX ZDAN_IDX ON USERS (ZDAN)';
  AdoCommand.CommandText := 'CREATE INDEX KAB_IDX ON USERS (KAB)';
  AdoCommand.CommandText := 'CREATE INDEX ETAJ_IDX ON USERS (ETAJ)';
  AdoCommand.CommandText := 'CREATE INDEX SPEED_IDX ON USERS (SPEED)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX RAM_IDX ON USERS (RAM)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX TYPE_IDX ON USERS (TYPE)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX CPU_IDX ON USERS (CPU)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX HDD_IDX ON USERS (HDD)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX OS_IDX ON USERS (OS)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX OSID_IDX ON USERS (OSID)';
  AdoCommand.Execute;
  AdoCommand.CommandText := 'CREATE INDEX BIOS_IDX ON USERS (BIOS)';
  AdoCommand.Execute;


  end else begin
{---}

  end;


 


end;

end.
